I don't usually leave comments but your explanation is so on point. Not too much not too little. Well done! I subscribed to the channel just by watching this video
Hey Team AlgoDaily, You are a great teacher. I like that you take your time and explain things in detail. Question, I understand that traditional two pointer (the pointers are in opposite ends) require the array to the sorted for the traditional two pointer to work. How about the sliding window, a variation of the two pointers? Does sliding window require the array like data structure to be sorted?
Thank you so much for explaining this concept in a clear manner. It was evident that you made an effort to communicate and impart knowledge. And yeah, I sure did learn. Thanks again for this charitable endeavor. Salute!!!
thankyou for explaining in a very easy manner that even a newbie to programming can understand the problem and its solution pretty well. Although I've two questions regarding the two problem examples you discussed. 1) do two pointer technique on TwoSum only work on a sorted array? I don't see accurate results on unsorted arrays. 2) in your problem # 2, will your solution work on a link list with a cycle hoping for more than 1 node?
Good job on your presentation! This helped me understand the basic two-pointer concept. My only suggestion would be to make a linked follow "suggested video" discussing what a "cycle" is. You are referring to this "cycle" as if it is a specific concept or data structure, as opposed to base/generic understanding of a cycle being anything that repeats in circular manner. Saying something like "A cycle in Python [or whatever language this is] is where you ping a database connection multiple times until you get a handshake. This can be the source of many headaches and hard to troubleshoot" ... Something like that. I just made that up, but you would of course give the actual explanation of what you are calling a #cycle AND a quick synopsis of why we care about finding one.
For Two Sum, wouldn't it be fewer loop iterations to use a HashMap to store each element's location in the array, then you could just do the following on each loop iteration: 1. Get the difference between the current value and the target. 2. Check to see if that value is already stored in the HashMap, if it is, we're done, so just return the current index, and the index stored in the HashMap. 3. If it wasn't found in the HashMap, store the current value and the current index in the HashMap for future lookups (see step 2). 4. If we've gone through each element and didn't find a match, there is no match. At worst you would be doing N iterations, it seems the worst case for the Two Pointer approach is greater than N iterations unless I'm missing something?
HashMap is also a good solution. But what about the space complexity? We are using a HashMap so it will become O(N). So the two-pointer approach is better than using a compliment hashmap IMKP
Thanks for the video. I haven't come across the cycle problem yet, so it's good to know how it works for when I encounter it. Great explanations and visuals!
Great video, thank you for the clear explanation :) My question is regarding using the 'two pointer' technique to check for cycles within the linked list, which you present towards the end of the video. Would using more pointers solve the question faster? So if we used 3 pointers, i.e, pointer 1 has a speed of x, pointer 2 -> 2x and pointer 3 -> 3x would we solve the question faster?
For the fast pointer to go back to node 3, i assume by default node 4 being last node has its "next" pointing to the previous node? Because if not, how will fast.next.next from node 3 move fast pointer back to node 3?
Yes since you can only traverse one way for both pointers and theres an assumption that behind the pointer is either smaller or bigger, depending on where the pointer started.
The program u showed for solving two sum doesn't work correctly as it fails to pass the second test on the leetcode platform because all combinations are not tried.
If you cant explain it to a 3rd grade student then you dont understand it. This guy gets it! Great tutorial!
I don't usually leave comments but your explanation is so on point. Not too much not too little. Well done! I subscribed to the channel just by watching this video
Same here
bot comment
So glad I ran into your channel; your way of making concepts visually understandable is a skill in its own right.
Hey Team AlgoDaily,
You are a great teacher. I like that you take your time and explain things in detail. Question, I understand that traditional two pointer (the pointers are in opposite ends) require the array to the sorted for the traditional two pointer to work. How about the sliding window, a variation of the two pointers? Does sliding window require the array like data structure to be sorted?
Thank you so much for explaining this concept in a clear manner. It was evident that you made an effort to communicate and impart knowledge. And yeah, I sure did learn. Thanks again for this charitable endeavor. Salute!!!
two pointers only work ,if it is a sorted array
yup
exactly!
Wrong. U can use two pointers in a non sorted array. Just look at leetcode 11
thankyou for explaining in a very easy manner that even a newbie to programming can understand the problem and its solution pretty well. Although I've two questions regarding the two problem examples you discussed.
1) do two pointer technique on TwoSum only work on a sorted array? I don't see accurate results on unsorted arrays.
2) in your problem # 2, will your solution work on a link list with a cycle hoping for more than 1 node?
Good job on your presentation! This helped me understand the basic two-pointer concept. My only suggestion would be to make a linked follow "suggested video" discussing what a "cycle" is. You are referring to this "cycle" as if it is a specific concept or data structure, as opposed to base/generic understanding of a cycle being anything that repeats in circular manner. Saying something like "A cycle in Python [or whatever language this is] is where you ping a database connection multiple times until you get a handshake. This can be the source of many headaches and hard to troubleshoot" ... Something like that. I just made that up, but you would of course give the actual explanation of what you are calling a #cycle AND a quick synopsis of why we care about finding one.
For Two Sum, wouldn't it be fewer loop iterations to use a HashMap to store each element's location in the array, then you could just do the following on each loop iteration:
1. Get the difference between the current value and the target.
2. Check to see if that value is already stored in the HashMap, if it is, we're done, so just return the current index, and the index stored in the HashMap.
3. If it wasn't found in the HashMap, store the current value and the current index in the HashMap for future lookups (see step 2).
4. If we've gone through each element and didn't find a match, there is no match.
At worst you would be doing N iterations, it seems the worst case for the Two Pointer approach is greater than N iterations unless I'm missing something?
HashMap is also a good solution. But what about the space complexity? We are using a HashMap so it will become O(N). So the two-pointer approach is better than using a compliment hashmap IMKP
Good introduction!
Your explanation is so on point! Thank you for a great video.
Thanks for the video. I haven't come across the cycle problem yet, so it's good to know how it works for when I encounter it. Great explanations and visuals!
So for the first example the two sum, would this one only applied to sorted array?
yes, because the elif sum < targetValue: pointerOne += 1 will not work on an unsorted array
I think the two-pointer technique is the same concept I recently read about in Cracking the Coding Interview, called the 'Runner Technique.'
Commenting for the algorithm, goodjob!
Amazing explanation, very clean and concise. Keep up the great work!
BANANA
You are an amazing teacher thanks for this
Goat tutorial
Such a great explaination!
Absolutely excellent explanations. Thank you!
loved the video! thanks for helping me understand this better
Great video and example thank you
Great video, thank you for the clear explanation :)
My question is regarding using the 'two pointer' technique to check for cycles within the linked list, which you present towards the end of the video.
Would using more pointers solve the question faster? So if we used 3 pointers, i.e, pointer 1 has a speed of x, pointer 2 -> 2x and pointer 3 -> 3x would we solve the question faster?
Great video
For the fast pointer to go back to node 3, i assume by default node 4 being last node has its "next" pointing to the previous node?
Because if not, how will
fast.next.next from node 3
move fast pointer back to node 3?
thank you my brother this is a really good tutorial!
Great Work!!!
nice video
is there any reason why the while loop condition cant be while the sum of the two pointers != target ?
You aren’t guaranteed to find the sum in the input array so using that loop condition may result in an infinite loop.
Does two pointer technique requires the array to be sorted?
Yes since you can only traverse one way for both pointers and theres an assumption that behind the pointer is either smaller or bigger, depending on where the pointer started.
Yes definitely, it will work only if the array is sorted
Yes
Nice content!
Thank you really you are so helpful instant subscribe
The program u showed for solving two sum doesn't work correctly as it fails to pass the second test on the leetcode platform because all combinations are not tried.
How can you assume the array is ascending if you just increased or decrease
Your 1000th Sub !!
my mind was blown
Thank u so much.
Awesome!
The goat
make more videos
gave you a follow brah
I am not smart enough to do this. I tried for 1 hour. Do not understand the results.
i love you
nah
stop explaining the theory and get into the practical syntax because none of this works
awesome video.
Great video